package io.github.sds100.keymapper.util.ui.compose.icons

import androidx.compose.ui.graphics.Color
import androidx.compose.ui.graphics.SolidColor
import androidx.compose.ui.graphics.vector.ImageVector
import androidx.compose.ui.graphics.vector.path
import androidx.compose.ui.unit.dp

val KeyMapperIcons.HomeIotDevice: ImageVector
    get() {
        if (_HomeIotDevice != null) {
            return _HomeIotDevice!!
        }
        _HomeIotDevice = ImageVector.Builder(
            name = "HomeIotDevice",
            defaultWidth = 24.dp,
            defaultHeight = 24.dp,
            viewportWidth = 960f,
            viewportHeight = 960f,
        ).apply {
            path(fill = SolidColor(Color(0xFF000000))) {
                moveTo(221f, 720f)
                quadTo(263f, 720f, 292f, 691f)
                quadTo(321f, 662f, 321f, 620f)
                quadTo(321f, 596f, 310f, 573f)
                quadTo(299f, 550f, 277f, 536f)
                lineTo(241f, 512f)
                lineTo(241f, 260f)
                quadTo(241f, 251f, 235.5f, 245.5f)
                quadTo(230f, 240f, 221f, 240f)
                quadTo(212f, 240f, 206.5f, 245.5f)
                quadTo(201f, 251f, 201f, 260f)
                lineTo(201f, 512f)
                lineTo(165f, 536f)
                quadTo(143f, 551f, 132f, 573f)
                quadTo(121f, 595f, 121f, 620f)
                quadTo(121f, 662f, 150f, 691f)
                quadTo(179f, 720f, 221f, 720f)
                close()
                moveTo(221f, 800f)
                quadTo(146f, 800f, 93.5f, 748f)
                quadTo(41f, 696f, 41f, 620f)
                quadTo(41f, 572f, 63f, 534f)
                quadTo(85f, 496f, 121f, 472f)
                lineTo(121f, 260f)
                quadTo(121f, 218f, 150f, 189f)
                quadTo(179f, 160f, 221f, 160f)
                quadTo(263f, 160f, 292f, 189f)
                quadTo(321f, 218f, 321f, 260f)
                lineTo(321f, 472f)
                quadTo(357f, 496f, 379f, 534f)
                quadTo(401f, 572f, 401f, 620f)
                quadTo(401f, 695f, 348.5f, 747.5f)
                quadTo(296f, 800f, 221f, 800f)
                close()
                moveTo(548f, 600f)
                quadTo(500f, 567f, 470f, 515f)
                quadTo(440f, 463f, 440f, 400f)
                quadTo(440f, 300f, 510f, 230f)
                quadTo(580f, 160f, 680f, 160f)
                quadTo(780f, 160f, 850f, 230f)
                quadTo(920f, 300f, 920f, 400f)
                quadTo(920f, 463f, 890f, 515f)
                quadTo(860f, 567f, 812f, 600f)
                lineTo(548f, 600f)
                close()
                moveTo(576f, 520f)
                lineTo(788f, 520f)
                quadTo(815f, 496f, 827.5f, 466f)
                quadTo(840f, 436f, 840f, 400f)
                quadTo(840f, 334f, 793f, 287f)
                quadTo(746f, 240f, 680f, 240f)
                quadTo(614f, 240f, 567f, 287f)
                quadTo(520f, 334f, 520f, 400f)
                quadTo(520f, 436f, 534.5f, 466f)
                quadTo(549f, 496f, 576f, 520f)
                close()
                moveTo(680f, 800f)
                quadTo(656f, 800f, 638f, 782f)
                quadTo(620f, 764f, 620f, 740f)
                lineTo(740f, 740f)
                quadTo(740f, 764f, 722f, 782f)
                quadTo(704f, 800f, 680f, 800f)
                close()
                moveTo(560f, 720f)
                lineTo(560f, 640f)
                lineTo(800f, 640f)
                lineTo(800f, 720f)
                lineTo(560f, 720f)
                close()
                moveTo(221f, 620f)
                quadTo(221f, 620f, 221f, 620f)
                quadTo(221f, 620f, 221f, 620f)
                quadTo(221f, 620f, 221f, 620f)
                quadTo(221f, 620f, 221f, 620f)
                lineTo(221f, 620f)
                lineTo(221f, 620f)
                lineTo(221f, 620f)
                lineTo(221f, 620f)
                lineTo(221f, 620f)
                quadTo(221f, 620f, 221f, 620f)
                quadTo(221f, 620f, 221f, 620f)
                quadTo(221f, 620f, 221f, 620f)
                quadTo(221f, 620f, 221f, 620f)
                close()
                moveTo(680f, 380f)
                quadTo(680f, 380f, 680f, 380f)
                quadTo(680f, 380f, 680f, 380f)
                quadTo(680f, 380f, 680f, 380f)
                quadTo(680f, 380f, 680f, 380f)
                quadTo(680f, 380f, 680f, 380f)
                quadTo(680f, 380f, 680f, 380f)
                quadTo(680f, 380f, 680f, 380f)
                quadTo(680f, 380f, 680f, 380f)
                close()
            }
        }.build()

        return _HomeIotDevice!!
    }

@Suppress("ObjectPropertyName")
private var _HomeIotDevice: ImageVector? = null
